import sys, base64, time
from random import randint
#from PyQt4 import QtCore, QtGui
from engine.as_http import asHttp
from engine.as_hlp import hlp
from base64 import b64encode as b64

#TODO чистить старые ошибки/ответы после разгадки
class asAc():

	key = ''
	ctype = 'jpg'
	url_send = 'http://antigate.com/in.php'
	url_get = 'http://antigate.com/res.php'
	url_bad = 'http://antigate.com/res.php?key=%s&action=reportbad&id=%s'
	tmp_name = '' # tmp name for captcha file
	tid = None

	error = False
	id = None # id of the uploaded captcha

	def __init__(self, parent, key, ctype='jpg', http=None, tid=None, http_main=None):
		self.parent = parent
		self.key = key
		self.http_main = http_main
		self.ctype = ctype
		self.http = http
		self.tid = tid
		self.hlp = self.parent.hlp
		self.cnf = self.parent.cnf
		self.proxy = self.parent.proxy
		self.captcha_body = None

	def log(self, text, ctype='~'):
		self.parent.log(text, ctype, self.tid)

	def recaptcha(self, captchaUrl, httpExternal=None, ref=None):

		if not httpExternal:
			httpExternal = self.http_main

		self.log('парсим ссылку с рекапчи')
		page = httpExternal.get(captchaUrl)

		chall = hlp.parse(r"challenge : '*VALUE2*", page)
		if chall is False:
			self.log('не смогли достать chall', '!')
			return False

		self.log('достали chall: ' + chall, '+')
		self.recaptcha_challenge = chall

		captcha_url = 'https://www.google.com/recaptcha/api/image?c=' + chall
		return self.captcha(captcha_url)

	def captcha(self, captchaUrl, httpExternal=None, ref=None):

		self.error = False
		self.log(('antigate: качаем ', captchaUrl))
		#self.tmp_name = 'tmp/captcha_%d.%s' % (randint(111, 9999), self.ctype)
		if not httpExternal:
			httpExternal = self.http_main

		self.captcha_body = httpExternal.set_ref(ref).getfile(captchaUrl, returnFileBody=True)

		if httpExternal.last_error:
			self.log('antigate: запрос не удался', '!')

			if self.cnf.getbool('proxy'):
				self.log('antigate: попробуем сменить прокси')
				if self.proxy.change(httpExternal) == 'no proxies':
					return False

			return self.captcha(captchaUrl, httpExternal, ref)

		if not self.captcha_body:
			self.error = 'пустой ответ сервера, не могу скачать капчу'
			return False

		fdata = b64(self.captcha_body).decode('utf-8', 'ignore')
		self.log('<img style="border: 1px solid black" src="data:image/{0};base64,{1}" />'.format(self.ctype, fdata))
		# отправляем на антигейт
		res = self._send()
		if res != 'ok':
			self.hlp.cnt('captchas_fails')
			self.error = True
			return res

		self.hlp.cnt('captchas')
		# ждем ответ
		return self._check()


	def _send(self):

		#http = Http()

		#~ with open(self.tmp_name, 'rb') as file:
			#~ captchaFile = file.read()

		data = {
			'method': 'base64',
			'key': self.key,
			'soft_id': '75',
			'body': base64.encodestring(self.captcha_body),
			'ext': self.ctype,
		}

		#~ self.http.proxy = ''
		#~ self.http.proxy_type = 3
		#~ self.http.proxy_port = ''

		if self.http.proxy.strip() != '':
			self.log('antigate: upload WARNING! proxy: {0}, type: {1}, port: {2}'.format(self.http.proxy, self.http.proxy_type, self.http.proxy_port), '!')

		res = self.http.post(self.url_send, data)
		if 'ERROR_WRONG_USER_KEY' in res:
			self.log('antigate: указан неправильный ключ антикапчи!', '!')
			hlp.stop()

		if 'OK|' in res:
			ok, self.id = res.split('|')
			return 'ok'

		elif 'ERROR_ZERO_BALANCE' in res:
			self.log('antigate: нет денег на счете', '!')
			hlp.stop()

		elif 'ERROR_NO_SLOT_AVAILABLE' in res:
			self.log('antigate: нет свободных слотов, ждем 5 сек.', '!')
			time.sleep(5)
		else:
			return res

	def _check(self):
		#http = Http()

		data = {
			'key': self.key,
			'action': 'get',
			'id': self.id.replace("'", ''),
		}

		while True:
			self.log('antigate: чекаем ответ')

			if self.http.proxy.strip() != '':
				self.log('antigate: check WARNING! proxy: {0}, type: {1}, port: {2}'.format(self.http.proxy, self.http.proxy_type, self.http.proxy_port), '!')

			res = self.http.post(self.url_get, data)
			self.log('antigate: ' + res)

			if 'OK|' in res:
				ok, text = res.split('|')
				return text.replace("'", '')
			elif 'ERROR_NO_SUCH_CAP' in res:
				self.error = True
				return 'ERROR_NO_SUCH_CAP captcha id invalid'
			elif 'ERROR_NO_SLOT_AVAILABLE' in res:
				self.log('antigate: все работники заняты', '-')
				time.sleep(10)

			time.sleep(3)


	def bad(self):

		url = self.url_bad % (self.key, self.id)
		res = self.http.get(url)

		self.hlp.cnt('captchas_fails')
		self.log('antigate: отправляем bad-report')


'''
app = QtGui.QApplication(sys.argv)

http = Http('test', app)
http.set_proxy('58.211.237.132:8000', 'http')

ac = Antigate(key='f4d489781bac21cad028b3108ad9977c', ctype='png')

res = ac.captcha('http://mamba.ru/captcha.php?r=0&name=reg_captcha&rand=')
if ac.error:
	print('ERROR:', res)
else:
	print('GET:', res)
'''
