import poplib, re
from urllib.parse import unquote
import quopri

class asMail():

	state = ''
	body = ''

	def __init__(self, parent=None):

		self.parent = parent
		# todo using asLog

	def _get_serv(self, name):
		db = \
		{
			'mail.ru': 'pop.mail.ru',
			'inbox.ru': 'pop.inbox.ru',
			'list.ru': 'pop.list.ru',
			'bk.ru': 'pop.bk.ru',
			'ukr.net': 'pop3.ukr.net',
			'meta.ua': 'pop.meta.ua',#ssl port 995
			'online.ua': 'pop3.online.ua',
			'gmail.com': 'pop.gmail.com',#ssl port 995
			'yandex.ru': 'pop.yandex.ru',#ssl port 995
			'yahoo.com': 'pop.mail.yahoo.com'#ssl port 995 нужны плаьные аккаунты
		}

		if name in db:
			return db[name]
		else:
			raise Exception

	def connect(self, email, searchRule, ssl=False, pop_port=110):

		self.state = ''
		self.body = ''
		try:
			login, server, password = re.findall('([^@]+)@([^:]+):(.+)', email)[0]
		except:
			self.parent.log('"%s" - неправильный формат. формат: LOGIN@server:PASSWORD' % email)
			return

		try:
			serv = self._get_serv(server)
		except:
			self.parent.log('неизвестный сервер %s' % server)
			return

		self.parent.log('подключаемся к %s' % serv)
		if not ssl:
			try:
				pop = poplib.POP3(serv, port=pop_port, timeout=5)
			except:
				self.parent.log('не удалось подключиться к %s, имейл %s' % (serv, email))
				return
		else:
			try:
				pop = poplib.POP3_SSL(serv, port=pop_port, timeout=5)
			except:
				self.parent.log('не удалось подключиться к %s, имейл %s' % (serv, email))
				return

		self.parent.log('подключились, блеадь. авторизуемся')
		if server in ['gmail.com', 'online.ua']:
			login = login + '@' + server
			self.parent.log(login)
		if b'+OK' not in pop.user(login):
			self.parent.log('неправильный логин %s' % login)
			self.state = 'login_fail'
			return

		try:
			res = pop.pass_(password)
		except Exception as ex:
			self.parent.log('не могу войти: %s' % str(ex))
			self.state = 'login_fail'
			return

		if b'+OK' not in res:
			self.parent.log('неправильный пароль %s' % password)
			self.state = 'login_fail'
			return

			self.parent.log('вошли')

		resp, ids, octets = pop.list()

		self.parent.log('на сервере: %s' % resp)
		total = len(ids)


		for i in range(total):
			curr = total - i
			if i > 10:
				break

			self.parent.log('качаем %d' % curr)
			src = pop.retr(curr)[1]

			body = b''
			for part in src:
				body += part

			body = quopri.decodestring(body)
			body = body.decode('utf-8', 'ignore')

			if searchRule not in body.lower():
				continue

			self.state = 'ok'
			self.body = body
			return

		self.parent.log('не нашли')
		return




if __name__ == '__main__':

	mail = asMail()
	mail.connect('icecybalehewa@mail.ru:FUSarokAvogeM', 'linkedin.com')

	if mail.is_success:
		self.parent.log(mail.body)



