window.hidden = false
window.autoscroll = true
window.parsedTids = {}
var startDate = new Date(); // for timer
window.timerInt = false // interval marker


document.onkeydown = function(e) {

    e = e || window.event;

    if(e.keyCode == 27) // Esc
    {
        stop_script()
	}
}

function g(id)
{
    return document.getElementById(id)
}

function ajax(url, callback)
{
    var xmlhttp = new XMLHttpRequest()
    xmlhttp.open('GET', url)

    xmlhttp.onreadystatechange = function ()
    {
        if (xmlhttp.readyState == 4 && xmlhttp.status == 200)
              callback(xmlhttp)
        else
            console.log('start.pyw function ajax fail')
    }

    xmlhttp.send(null);
}

function setBalance(xmlhttp)
{
    g('ac_balance').innerHTML = xmlhttp.responseText
}

function updateBalance()
{
    ajax('engine/get_ac_balance.py?key=' + window.ac_key, setBalance)
}

function setStartButton()
{
	cnf_id = queryString('cnf_id')
	mod = queryString('mod')

	if(mod != false)
		mod_text = '&mod=' + mod
	else
		mod_text = ''

	st_text = g('start_text').innerHTML

	if(cnf_id != false)
		g('stopplace').innerHTML = '<a href="?start=1&cnf_id=' +cnf_id + mod_text + '">'+st_text+'</a>'
	else
		g('stopplace').innerHTML = '<a href="?start=1' +mod_text+ '">'+st_text+'</a>'
}

function stop_script()
{
	clearInterval(window.scroller)
	clearInterval(window.timerCnt)
	clearInterval(window.timerInt)

	if(document.title.indexOf('[STOP]') == -1)
		document.title = '[STOP] ' + document.title

	g('flashbang').style.display = 'inline'

    ajax('engine/set_stop.py', setStartButton)
    g('pWithLoadingGif').style.display = 'none'
}

function queryString(parameter) {
  var loc = location.search.substring(1, location.search.length);
  var param_value = false;

  var params = loc.split("&");
  for (i=0; i<params.length;i++) {
      param_name = params[i].substring(0,params[i].indexOf('='));
      if (param_name == parameter) {
          param_value = params[i].substring(params[i].indexOf('=')+1)
      }
  }
  if (param_value) {
      return param_value;
  }
  else {
      return false; //Here determine return if no parameter is found
  }
}

function filterInit()
{
    qs = document.querySelector('#mainBody')
    logs = qs.querySelectorAll('p.logline')

    g('logFilterSpan').style.display = 'inline'

    if(logs.length <= 0)
		return

    for(var i = 0; i < logs.length; i++)
    {
        try{
            tid = logs[i].getAttribute('threadid', 2)
        }catch(e){
            continue
        }

        tid = tid.replace('#', '')

        if(tid == ' ' || tid == '')
            continue

        window.parsedTids[tid] = tid
    }

    tids = []
    for(tid in window.parsedTids)
		tids.push(tid)

    tids.sort()

	newdata = []
    while(tids.length)
    {
		val = tids.pop()
        newdata.push('<option value="#' +val+ '">#' +val+ '</option>')
	}

    g('filterSelect').innerHTML += newdata.join("")
}

function filterLog(id)
{
    qs = document.querySelector('#mainBody')
    logs = qs.querySelectorAll('p.logline')

    if(logs.length > 0)
    for(i = 0; i < logs.length; i++)
    {
        if(id == 'all')
        {
            logs[i].style.display = 'block'
            continue
        }

        try{
            tid = logs[i].getAttribute('threadid', 2)
        }catch(e){
            continue
        }

        if(tid != id)
        {
            logs[i].style.display = 'none'
        }else{
            logs[i].style.display = 'block'
        }

    }
}

function scr()
{
    //if(g('autsrcl').checked)
    if(window.autoscroll)
        g('mainBody').scrollTop = parseInt(g('mainBody').scrollHeight + 2000);
}

function ap(s)
{
    if(s.substr(0, 9) == 'Traceback')
        s = '<span style="background-color: #F4FFA5; padding: 2px; margin: 3px;">' + s.replace('<br />', '') + '</span><br />'
    g("errlog").innerHTML += s
    g("errlog_base").style.display = 'block'
}

function switch_autoscroll()
{
    window.autoscroll = window.autoscroll ? false : true
}

function cnt(name, mode, value)
{
    mode = (typeof(mode) != 'undefined') ? mode : 'inc'
    value = (typeof(value) != 'undefined') ? value : 0

    elem = g('cnt_' + name)

    if(!elem){
        g("errlog").innerHTML += 'Bad counter: ' + name
        return
    }

    var currentVal = parseInt(elem.innerHTML)

    if(mode == 'inc')
    {
        currentVal++
    }else if(mode == 'dec'){
        currentVal--
    }else if(mode == '+='){
        currentVal += parseInt(value)
    }else{
        currentVal = value
    }

    g('cnt_' + name).innerHTML = currentVal
}

function change()
{
    if(window.hidden)
    {
        g('errlog').style.display = 'block'
        window.hidden = false
    }else{
        g('errlog').style.display = 'none'
        window.hidden = true
    }
}

function show_preview(href)
{
    g('preview_html').style.display = 'block'
    g('preview_html').src = href
}

function hide_iframe()
{
    g('preview_html').style.display = 'none'
}

function setCnts(xmlhttp)
{
	if(xmlhttp.responseText.length > 10)
	{
		g('counters').innerHTML = xmlhttp.responseText
	}
}

function updateCounters(cnf_id)
{
	if(cnf_id != '' && cnf_id != undefined)
		ajax('engine/get_cnts.py?cnf_id=' + cnf_id, setCnts)
	else
		ajax('engine/get_cnts.py', setCnts)
}

function timer()
{
    var theDate = new Date();
    var differ = theDate - startDate;
    var hours, minutes, seconds;
    hours = Math.floor(differ/(1000*60*60));
    hours = (hours > 59) ? hours%60 : hours;
    hours = (hours < 10) ? '0' + hours : hours;

    minutes = Math.floor(differ/(1000*60));
    minutes = (minutes > 59) ? minutes%60 : minutes;
    minutes = (minutes < 10) ? '0' + minutes : minutes;

    seconds = Math.round(differ/1000);
    seconds = (seconds > 59) ? seconds%60 : seconds;
    seconds = (seconds < 10) ? '0' + seconds : seconds;

    var strDate =  hours + ':' + minutes + ':' + seconds;
    g('cnt_timepad').innerHTML = strDate;
}

function init(cnf_id)
{
	window.scroller = window.setInterval('scr()', 100);

	window.timerCnt = window.setInterval(function() {updateCounters(cnf_id);}, 1000);

	window.timerInt = window.setInterval('timer()', 1000);
}
