#!/usr/local/bin/python3
# coding=utf-8
import sys, os, cgi, random, subprocess, time, traceback
from engine.as_hlp import hlp
from engine.problems import check_problems
from engine.config_editor_class import Config

cnf = Config('config.ini')
cnf.parseLang()

form = cgi.FieldStorage()
sys.stdout.buffer.write(b'Content-type: text/html;charset=utf-8\n\n')

if 'cnf_id' in form:
	cnf_id = form.getvalue('cnf_id')
	cnf_text = '?cnf_id=' + cnf_id

elif len(sys.argv) > 2 and sys.argv[2].startswith('cnf_id='):
	n, cnf_id = sys.argv[2].split('=')
	cnf_text = '?cnf_id=' + cnf_id

else:
	cnf_id = False
	cnf_text = ''

cnf_text2 = cnf_text.replace('?','')
cnf_path = 'config.ini' if not cnf_id else 'configs/%s/config.ini' % cnf_id
db_path = 'data.db' if not cnf_id else 'configs/%s/data.db' % cnf_id


if sys.argv[0] == 'start.pyw':
	RUN_MODE = 'console'
else:
	RUN_MODE = 'cgi'

try:
	cmd = sys.argv[1]
except:
	cmd = ''

if 'start' in form:
	cmd = 'start'

# если запущен и это не отдельная задача
if cmd == 'start' and cnf_text == '':
	proc = subprocess.Popen(r'ps axo tid,etime,%cpu,user,command | grep python3', shell=True,
				stdout=subprocess.PIPE, stdin=subprocess.PIPE)

	processes = b''
	while True:
		processes += proc.stdout.read(1024)

		if proc.poll() is not None:
			break

	processes = processes.decode('utf-8', 'ignore').split('\n')

	check_path = '%s/start.pyw' % os.path.basename(os.getcwd())
	proc = [p for p in processes if check_path in p]

	if len(proc) > 1:
		print('''<p><b>script already started!</b><br />
		<a href="start.pyw%(cnf_text)s">script</a><br />
		<a href="config_editor.py%(cnf_text)s">config</a><br />
		<a href="fileed_sql.py%(cnf_text)s">data</a><br />
		<a href="cp.py%(cnf_text)s">panel</a><br />
		</p>''' % locals())
		for row in proc:
			pid = row.split(' ')[0]
			print('<a href="cp.py?cmd=kill&pid={0}">[x]</a> {1}'.format(pid, row), '<br />')
		sys.exit(0)

check_problems()

class MyErr(object):
	def __init__(self):
		sys.stderr = self

	def write(self, line):
		#app.log('<!-- %s -->' % line, hide=True)
		line = cgi.escape(line).replace(' ', '&nbsp;').replace('(', '\\(').replace(')', '\\)').replace('\n', '<br />').replace('"', '\\"')
		app.log('<script>ap("%s")</script>' % line, hide=True)

	def flush(self):
		pass

if RUN_MODE == 'cgi':
	myerr = MyErr()

os.dup2(1, 2)

from engine.as_base import asBase

try:
	app = asBase(db_path=db_path, cnf_path=cnf_path, cnf_id=cnf_id, runmode=RUN_MODE, lightload=bool(('start' not in cmd)))
except Exception as ex:
	print('Cannot init asBase: %s' % ex)
	print(traceback.print_exc(file=sys.stdout))

# ставим текущий PID в базу, чтобы отслеживать
app.sqlite.exec('update _settings set `value` = "%s" where option = "current_pid"' % os.getpid())

#~ while True:
	#~ app.log('test')
	#~ time.sleep(3)
#~
#~ sys.exit(0)


print("<script src='res/jquery-1.6.2.min.js'></script>")
app.log('<html><head><title>asfw</title><link href="res/asfw.css?rnd=%d" rel="stylesheet" type="text/css" /><meta name="robots" content="noindex" /><meta name="robots" content="nofollow" /></head><body>' % random.randint(0, 100), hide=True)
app.log('''<!-- привет я джек я пью ягу я алкоголик --><noscript>

	<p style='border: 1px solid #689; width: 400px; background-color: #FF9393; z-index: 9999; padding: 10px; margin: 0 auto; text-align: center; position: absolute; margin-top: 20px; margin-left: 300px; font-size: 120%'>javascript disabled</p>
</noscript>
<script>
function closeSettings()
{
	$('#settings').hide()
}
</script>
''', hide=True)

app.log('<script>window.ac_key = "%s"</script><script src="res/interface.js?rnd=%d"></script>' % (app.cnf.get('ac_key'), random.randint(0, 100)), hide=True)


app.log('''
<iframe id='settings' src='config_editor.py?framesrc=1&{0}' style='position: absolute; left: 10px; top: 55px; width: 1200px; height: 610px; z-index: 999; border: 0px solid black; display: none; overflow: scroll'></iframe>
<iframe id='preview_html'></iframe>
<span id='flashbang' style='display: none'><object width='0' height='0'><param name='movie' value='res/bang.swf'><embed src='res/bang.swf' width='0' height='0'></embed></object></span>
<div id='errlog_base' class='opacity'>
	<a href='javascript: return undefined' onclick='change()'><p id='hidebtn'>Runtime Errors</p></a>
	<div id='errlog'></div>
</div>
<div style='position: absolute; right: 50px; color: #777; top: 10px; font-size: 90%'>{1} $<span id='ac_balance'>0</span> <a href='javascript: updateBalance()'>{2}</a><br />
{3}</div>
<div id='start_text' style='display:none'>{4}</div>
<div id='stop_text' style='display:none'>{5}</div>
<div id='mainBody' onclick='switch_autoscroll()'>
'''.format(cnf_text2, cnf.trans('баланс antigate'), cnf.trans('обновить'), cnf.trans('щелчок по логу - вкл./откл. автопрокрутку'), cnf.trans('ЗАПУСК'), cnf.trans('СТОП')), hide=True)

print('\n<!--', '='*100, '-->\n\n')


if 'start' in cmd:
	part1 = [('javascript:stop_script()', cnf.trans('СТОП'))]
else:
	if 'mod' in form:
		part1 = [('?start=1&mod=' + form.getvalue('mod') + '&' + cnf_text2, cnf.trans('ЗАПУСК'))]
	else:
		part1 = [('?start=1&' + cnf_text2, cnf.trans('ЗАПУСК'))]

mods = [f.replace('mod_','').replace('.py', '') for f in os.listdir('include') if f.startswith('mod_')]
mods_data = {}
for mod in mods:
	with open('include/mod_%s.py' % mod, 'rb') as fp:
		page = fp.read().decode('utf-8')
		name = hlp.parse(r"<name>(.*?)</name>", page)
		descr = hlp.parse(r"<descr>(.*?)</descr>", page)
		if name and descr:
			t_name = cnf.trans(name.strip())
			t_descr= cnf.trans(descr.strip())
			mods_data[mod] = {'name': t_name, 'descr': t_descr}

part2 = [('--', '--')]

for m in mods:
	part2 += [('start.pyw?mod=' +m+ '&' + cnf_text2, m)]

activemod = form.getvalue('mod', mods[0])

part2 += [
	('cp.py?cmd=start&mod='+activemod, cnf.trans('в фоне')),
	('--', '--'),
	('start.pyw', cnf.trans('стоп')),
	('--', '--'),
	('javascript:show_sett()', cnf.trans('настройки')),
	('fileed_sql.py' + cnf_text, cnf.trans('данные')),
	('cp.py' + cnf_text, cnf.trans('панель')),
]

menus = part1 + part2


menuString = ''
menuString2 = []
for item in menus:
	if item[1] == cnf.trans('СТОП'):
		menuString += '<span id="stopplace"><a href="javascript:stop_script()">{0}</a></span>&nbsp;&nbsp;'.format(cnf.trans('СТОП'))
	elif item[1] == '--':
		menuString += '&nbsp;/&nbsp;&nbsp;'
	elif item[0] == 'javascript:show_sett()':

		menuString += '''
		<span title='{0}' style='border-bottom: 1px dotted black' onclick='return show_sett()'>{1}</span> <a href='config_editor.py{2}' target='_blank' style='font-weight: bold' title='{3}'>&raquo;</a>
		&nbsp;&nbsp;
		'''.format(cnf.trans('Открыть настройки поверх лога'), cnf.trans('настройки'), cnf_text, cnf.trans('Открыть настройки в новом окне'))
	else:
		# подсвечуем активный мод
		if activemod and 'mod=' + activemod + '&' in item[0] and 'start=1' not in item[0] and not 'cp.py' in item[0]:

			link = hlp.lnk(item[0], mods_data[item[1]]['name'])
			row = '<p style="background-color: #eee; border: 1px solid #2B8EFF; background-color: #AAD1FF; padding: 3px; padding-top: 1px">&nbsp;&nbsp;{0} - {1}</p>'.format(link, mods_data[item[1]]['descr'])
			menuString2.append(row)

		elif item[1] in mods_data:

			link = hlp.lnk(item[0], mods_data[item[1]]['name'])
			row = '<p>&nbsp;&nbsp;{0} - {1}</p>'.format(link, mods_data[item[1]]['descr'])
			menuString2.append(row)

		else:
			menuString += hlp.lnk(item[0], item[1]) + '&nbsp;&nbsp;'

if 'start' in cmd:
	menuString += '''<span id='logFilterInitSpan'><a title='{1}' href='javascript: undefined' onclick='filterInit()'>{0}</a> </span><span id='logFilterSpan' style='display: none'><select id='filterSelect' style='border: 1px solid black' onChange='filterLog(this.options[selectedIndex].value)' onKeyDown="filterLog(this.options[selectedIndex].value)"; onKeyUp="filterLog(this.options[selectedIndex].value)">
<option value='all'>{2}</option>
<option value=''>{3}</option></select></span>'''.format(cnf.trans('фильтр'), cnf.trans('рекомендуется инициализация только после остановки скрипта'), cnf.trans('все потоки'), cnf.trans('главный'))


app.log("""<div id='cp'>%s</div>
<script>
function show_sett()
{
	$('#settings').toggle()
	return false
}
</script>
""" % menuString, hide=True)

if 'start' not in cmd:
	with open('README', 'rb') as fp:
		softname = hlp.parse(r'название: (.*)', fp.read().decode('utf-8'))

	app.log('''<div style="padding: 5px; background-color: #eee; width: 700px; border: 1px solid #666; background-image: url(\'res/back_dark.gif\'); margin: 0 auto;">

	<center><span style="font-size: 120%;">{3} <b>{0}</b></span><br />{1}</center>

	<!-- mods menu -->
	<p>{2}</p>

<center><a href="manual.html">{4}</a></center></span>
</div>
'''.format(mods_data[activemod]['name'], mods_data[activemod]['descr'], ''.join(menuString2), softname, cnf.trans('инструкция по использованию')), hide=True)

	sys.exit(0)

if cnf_id:
	app.log("<script>init({0})</script>".format(cnf_id), hide=True)
else:
	app.log("<script>init('')</script>", hide=True)

app.log('''<div id='countersMain' class='opacity1'>
<b style='float: right; border-bottom: 1px dotted black' onclick='$("#counters").toggle()'>{2}</b><br />
{1}: <span id='cnt_timepad'>00:00:00</span><br />
<span id='counters'><iframe src='engine/get_cnts.py?mode=ifr&{0}' style='border: 0; width: 220px; height: 250px;'></iframe><p id='pWithLoadingGif' style='text-align: center'><img src='res/loading.gif' alt='loading..' /></p></span></div>
'''.format(cnf_text2, cnf.trans('Время'), cnf.trans('счетчики')), hide=True)

app.run(form.getvalue('mod', mods[0]))


