#!/usr/local/bin/python3
import sys, os, cgi, cgitb
from engine.config_editor_class import Config

os.dup2(1, 2)

sys.stdout.buffer.write(b'Content-type: text/html;charset=utf-8\n\n<html><head><title>Config Editor</title></head><body>')
form = cgi.FieldStorage(keep_blank_values=True)

if 'cnf_id' in form:
	cnf_id = form.getvalue('cnf_id')
	cnf_text = '?cnf_id=' + cnf_id
else:
	cnf_id = False
	cnf_text = ''

cnf_path = 'config.ini' if not cnf_id else 'configs/%s/config.ini' % cnf_id

def _print(text):
	sys.stdout.buffer.write(text.encode('utf8'))
	sys.stdout.flush()

cnf = Config(cnf_path)
cnf.parseLang()

cnf.loadFile()

items = cnf.getBlocks()

_print('''<style type='text/css'>
* {font-family: Verdana; font-size: 95%}
BODY {background-image: url('res/back.gif')}
A {color: black}
A:hover {color: red}
#tables {position: fixed; top: 20px; left: 20px; border: 1px solid #031DB2; padding: 5px; background-color: #B0BCFC; width: 290px;
}
#err {text-align: center; border: 1px solid #944; width: 400px; margin: 0 auto; padding: 5px; background-color: #FFB5B5;margin-top: 5px;}
#ok {text-align: center; border: 1px solid #016300; width: 400px; margin: 0 auto; padding: 5px; background-color: #BDFFBC;margin-top: 5px;}
#actions {border: 1px solid #E5E500; padding: 5px; background-color: #FFFF96; position: fixed; right: 20px; top: 20px; width: 300px;}
.logline {
	margin: 0;
	padding: 2px;
	padding-left: 15px;
}

FIELDSET {
	margin-top: 5px;
	border: 0;
	display: none;
	position: fixed;
	top: 50px;
	left: 20px;
	width: 100%;
	/* background-image: url('res/back_dark.gif') */
}

LEGEND {
	border: 0px solid black;
	padding: 2px;
	padding-right: 25px;
	padding-left: 25px;
	background-color: #FFE967;
	display: none;
}
.drk {
	background-color: #eee;
}

#menu LI {
	display: inline;
	margin-left: 5px;
	padding: 5px;
	padding-left: 5px;
	padding-right: 5px;
	background-color: #FFE967;
	border: 1px solid black;
}

#menu LI:hover, #menu LI INPUT:hover {
	background-color: white;
}

#menu LI INPUT {
	background-color: #FFE967;
}
</style>

<script>
function toggle(id)
{
	elem = document.getElementById('span_' + id)

	if(elem.style.display == 'none')
		elem.style.display = 'block'
	else
		elem.style.display = 'none'
}

function show(id)
{
	for(i = 0; i < window.maxBlocks; i++)
	{
		var data = document.getElementById('test' + i)
		var li = document.getElementById('lee' + i)

		if(i == id)
		{
			data.style.display = 'block'
			li.style.backgroundColor = '#fff'
		}else{
			data.style.display = 'none'
			li.style.backgroundColor = '#ffe967'
		}
	}
}
''')

_print('window.maxBlocks = %d; </script><body>' % len(items))

_print('''
<form action="config_editor.py{0}" method="post" style="font-size: 100%">
<div style='display: none; filter:progid:DXImageTransform.Microsoft.Alpha(opacity=60); -moz-opacity: 0.6; -khtml-opacity: 0.6; opacity: 0.6;
z-index: 9999999; position: fixed; text-align: center; top: 30px; right: 60px;
border: 1px solid black; background-color: #eee; width: 350px; padding: 10px'><h2>РЕДАКТОР НАСТРОЕК</h2><input type='button' onclick='document.location.href="start.pyw"; window.location=start.pyw;' value='&laquo; {2}' style='width: 100px; font-weight: bold' />&nbsp;&nbsp;
<input type='submit' value='{1}' style='width: 200px; font-weight: bold' />
<!-- Упс, герой, для тебя плохие вести - ты проиграл в этом бою, домой поедешь грузом 200 -->
</div>

<div style='margin-top: 20px;'>
	<ul id='menu'>'''.format(cnf_text, cnf.lang_rows.get('СОХРАНИТЬ', 'СОХРАНИТЬ'), cnf.lang_rows.get('назад', 'назад')))



if 'framesrc' not in form:
	_print('<li style="margin-right: 30px" onclick=\'document.location.href="start.pyw"; window.location=start.pyw;\'>&laquo; {0}</li>'.format(cnf.lang_rows.get('назад', 'назад')))

for i, item in enumerate(items):
		item = cnf.lang_rows.get(item, item)
		if item in ['прокси','движок','proxies','engine']:
			item = '<b>{0}</b>'.format(item)
		_print('<li id="lee%d" onmouseover=\'show("%d")\'>%s</li>' % (i, i, item))

if 'framesrc' in form:
	closeX = "<li onclick='parent.closeSettings()' style='font-weight: bold;  margin-left: 10px'>X</li>"
else:
	closeX = ''

_print("""<li style='margin-left: 30px'><input type='submit' value='{0}' style='border: 0; font-weight: bold' /></li>
		{1}
</ul></div>""".format(cnf.lang_rows.get('СОХРАНИТЬ', 'СОХРАНИТЬ'), closeX))


if os.environ['REQUEST_METHOD'] == 'POST':
	cnf.postSave(form)
	#_print('<p style="text-align: center; font-weight: bold; color: blue;">сохранено</p>')

cnf.draw()

_print('</form>')

#~ if not os.path.exists('/home/deex'):
	#~ _print('''
#~ <script> // ХАКИ
#~ elem = document.getElementsByName("proxy")[1]
#~ elem.checked = true
#~ elem.style.display = 'none'
#~ </script>
#~ ''')

_print('<script>show("0")</script>')





