import re
#from PyQt4 import QtCore, QtGui

#from engine.ui_main import Ui_MainWindow
     
#QtGui.QMainWindow
class asGui():
    ''' QMainWindow '''
    
    def __init__(self, app, parent):

        #QtGui.QWidget.__init__(self)
        self.app = app
        self.parent = parent
        self.ui = False#Ui_MainWindow()
        #self.ui.setupUi(self)
        
    #def connectButtons(self, *args):
    #
    #    # автоподключение кнопок с двумя _:
    #    # pushButton__module_method вызывает module.method()        
    #    with open('engine/ui_main.py', 'r') as file:
    #        gui_source = file.read()
    #    
    #        matches = re.findall('self.pushButton__([a-zA-Z0-9\_]+)', gui_source)
    #        matches = list(set(matches))
    #        
    #        for match in matches:
    #            mod, meth = match.split('_')
    #            module = getattr(self.parent, mod)
    #            to = getattr(module, meth)
    #            QtCore.QObject.connect(getattr(self.ui, 'pushButton__' + match),
    #                                   QtCore.SIGNAL('clicked()'), to)     
    #
    #    for name in args:
    #        what = getattr(self.ui, 'pushButton_' + name)
    #        to = getattr(self.parent, 'button_' + name)
    #        QtCore.QObject.connect(what, QtCore.SIGNAL('clicked()'), to)
            
    def chkbox(self, name, op=True):
        chk = getattr(self.ui, 'checkBox_' + name)

        if op == 'get':
            return chk.isChecked()

        chk.setChecked(op)           
            
    def radio(self, name, op=True):
        chk = getattr(self.ui, 'radioButton_' + name)
     
        if op == 'get':
            return chk.isChecked()       

        chk.setChecked(op)
          
    def combo(self, name, op='set', value=''):
        elem = getattr(self.ui, 'comboBox_' + name)
        
        if op == 'set':
            elem.setCurrentIndex(value)
        elif op == 'add':
            elem.addItem(value[0], value[1])
        elif op == 'select':
            index = elem.findData(value)
            self.combo(name, 'set', index)
        elif op == 'getvalue':
# 0 - is Qt.DisplayRole
# http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qt.html#ItemDataRole-enum
            return elem.itemData(elem.currentIndex(), 0)
        else:
            return elem.currentIndex()
        
    def logger(self, text, type='~', vars=None):

        print('[' + type + ']', text)
        
        if vars:
            text = str(text) % vars
        else:
            text = str(text)

        if type == '!':
            color = 'red'
        elif type == '*':
            color = 'orange'
        elif type == '+':
            color = 'blue'
        elif type == '-':
            color = '#2EC933'
        elif type == '$':
            color = '#C9C200'
        elif type == '~':
            color = '#777; font-style: italic'
        else:
            color = ''

        #self.plainTextEdit('log', 'add', text)
        if color:
            text = '<span style="color: %s">%s</span>' % (color, text)
        
        #self.textEdit('log', 'add', text)
        print(text)
        #self.app.processEvents()
            
    def textEdit(self, name, op='getlist', data=''):

        edit = getattr(self.ui, 'textEdit_' + name)

        if op == 'getlist':
            return [r for r in edit.toPlainText().split('\n') if r.strip()]
        if op == 'getlisthtml':
            return [r for r in edit.toHtml().split('\n') if r.strip()]            
        elif op == 'gettext':
            return edit.toPlainText()
        elif op == 'gethtml':
            return edit.toHtml()            
        elif op == 'add':
            edit.append(data)
        elif op == 'clear':
            edit.setHtml('')
        elif op == 'set':
            edit.setHtml(data)
            
    def lbl(self, name, op='+', new=''):
        ''' labels helper '''
        
        return
    
        label = getattr(self.ui, 'label_' + name)

        if op != 'set':
            val = int(label.text())
            if val == 0 and op == '-':
                return

        if op == '-':
            val -= 1
        elif op == '=' or op == 'set':
            val = new
        elif op == 'clear':
            val = ''
        else:
            val += 1

        label.setText(str(val))
        
    def lineEdit(self, name, op='get', value=''):

        line = getattr(self.ui, 'lineEdit_' + name)

        if op == 'get':
            return line.text()
        elif op == 'clear':
            line.clear()
        elif op == 'set':
            line.setText(str(value))
            
    def plainTextEdit(self, name, op='getlist', data=''):
        ''' plainTextEdit methods '''

        edit = getattr(self.ui, 'plainTextEdit_' + name)

        if op == 'add' or op == 'set':
            if type(data) == type([]):
                data = "\n".join(data)        
                
        if op == 'getlist':
            return [r for r in edit.toPlainText().split('\n') if r.strip()]
        if op == 'getsize':
            return len([r for r in edit.toPlainText().split('\n') if r.strip()])
        elif op == 'gettext' or op == 'get':
            return edit.toPlainText()
        elif op == 'add':
            edit.appendPlainText(data)
        elif op == 'clear':
            edit.clear() # .setPlainText('')    
        elif op == 'set':
            edit.setPlainText(data)
        elif op == 'del':
            list = self.plainTextEdit(name, 'gettext')

            if data + '\n' in list:
                newlist = list.replace(data + '\n', '')
            else:
                newlist = list.replace(data, '')

            edit.setPlainText(newlist.strip())            
            
    
    def closeEvent(self, event):
        self.parent.threads.close(event)
            
            
            
            
            
            
            
            