#!/usr/local/bin/python3
import sys, cgi, sqlite3, os
sys.stdout.buffer.write(b'Content-type: text/html;charset=utf-8\n\n')

def _print(text):
	sys.stdout.buffer.write(text.encode('utf8'))
	sys.stdout.flush()

form = cgi.FieldStorage()

path = '../counters' if 'cnf_id' not in form else '../configs/%s/counters' % form.getvalue('cnf_id')

with open(path, 'rb') as fp:
	data = fp.read().decode('utf-8', 'ignore')
	rows = data.split('\n')

cdata = {}
for row in rows:
	if not row.strip():
		continue
	name, value = row.strip().split(':')
	cdata[name] = value

#~ names = ['threads',
#~ 'proxies',
#~ '--',
#~ 'captchas',
#~ 'captchas_fails',
#~ '--',
#~ 'valid',
#~ 'invalid',
#~ 'not_confirmed',
#~ '--',
#~
#~ ]

counters = {}
# пишем счетчики в память
with open('counters.map', 'rb') as fp:
	data = fp.read().decode('utf-8')

	for l in data.split('\n'):
		if not l.strip():
			continue
		num, name, descr, value = l.split(':')
		counters[num] = {'name':name, 'value':value, 'descr':descr}

html = ''
#print(counters)
for key, counter in sorted(counters.items()):
	name = counter['name']
	if name == '--':
		html += '<br />'
	else:
		if os.path.exists('../res/lang'):
			t_name = name
		else:
			t_name = counter['descr']
		html += '{0}: {1}<br />\n'.format(t_name, cdata[key])

_print(html)

#~ db_path = '../data.db' if 'cnf_id' not in form else '../configs/%s/data.db' % form.getvalue('cnf_id')
#~
#~ conn = sqlite3.connect(db_path, isolation_level='IMMEDIATE')
#~ cursor = conn.cursor()
#~ data = cursor.execute('select * from _counters').fetchall()
#~
#~ if 'mode' in form:
	#~ _print('<style type="text/css">* {margin: 0;padding: 0;} #counterspad { font-family: Verdana; font-size: 80%}</style><div id="counterspad">')
#~
#~ for name, fullname, value in sorted(data):
	#~ def_v = 0
#~
	#~ _print("%s: <span id='cnt_%s'>%s</span><br />" % (fullname, name, value))
#~
#~ if 'mode' in form:
	#~ _print('</div>')
