#!/usr/local/bin/python3
import os, sys, cgi, urllib.request, subprocess
from as_hlp import hlp
os.dup2(1, 2)
sys.stdout.buffer.write(b'Content-type: text/html;charset=utf-8\n\n')

from config_editor_class import Config

cnf = Config('config.ini')
cnf.parseLang()

def _print(text):
	sys.stdout.buffer.write(text.encode('utf8'))
	sys.stdout.flush()

def txt(phrases, body):
	''' ищет фразы списка phrases в body '''

	if isinstance(phrases, str):
		phrases = [phrases]

	for phrase in phrases:
		if phrase in body:
			return True

	return False

# ищем питонов
proc = subprocess.Popen(r'ps axo tid,etime,%cpu,user,command | grep python3 | grep start', shell=True,
			stdout=subprocess.PIPE, stdin=subprocess.PIPE)

processes = proc.stdout.read()
#~ processes = b''
#~ while True:
	#~ processes += proc.stdout.read(1024)
#~
	#~ if proc.poll() is not None:
		#~ break

processes = processes.decode('utf-8', 'ignore').split('\n')

processes = [proc for proc in processes if 'rlwrap' not in proc and 'sh ' not in proc]
#print(processes)



#pids = [l.split(' ')[0] for l in processes if ' ' in l]

#~ paths = {}
#~ for pid in pids:
	#~ path = hlp.execute('readlink /proc/{0}/cwd'.format(pid), silent=False)
	#~ #print('readlink /proc/{0}/cwd: {1}'.format(pid, path))
	#~ paths[pid] = path

#print(paths)
#sys.exit(0)


#тут достаем пути для кожного
#pgrep -f start.pyw | xargs -I ^ sh -c "echo -n ^ --; readlink /proc/^/cwd"


def formatProc(text):
	# 21743 deex     /usr/bin/Thunar --daemon
	data = [t.strip() for t in text.split(' ') if t.strip()]

	if not len(data):
		return ''

	pid =  data.pop(0)
	etime =  data.pop(0)
	cpu =  data.pop(0)
	user = data.pop(0)
	comm = " ".join(data)

	new = '#%s %s %s %s  %s%%<br />' % (pid, user, etime, comm, cpu)

	notice = cnf.trans('убить процесс принудительно командой kill')

	c_pid = '<span style="color: blue">%s</span>' % pid
	c_comm = '<span style="color: #AA0F0F">%s</span>' % comm
	newcolor = '#%s %s   <small>%s</small>   %s <a href="cp.py?cmd=kill&pid=%s" title="%s">[x]</a>    %s%%<br />' % (c_pid, user, etime, c_comm, pid, notice, cpu)

	if txt(['grep', 'cp.py', 'get_cnts.py', 'get_processes'], comm):
		return '<span style="color: grey">%s</span>' % new
	else:
		return newcolor


processes = [formatProc(proc) for proc in processes if proc is not None]

_print("".join(processes))



